
function output = spike_step(t, dt, structure, inp_vec, neuromodulator)

if rand(1)>0.8
    noise=(rand(1, length(structure.potential(t,:)))-0.5).*structure.noise;
else
    noise=zeros(1, length(structure.potential(t,:)));
end

%structure.baseline=structure.baseline + ((rand(1, length(structure.activity(t,:)))*2-1)/10) .*structure.noise;

%action potential
structure.potential(t,:) = structure.potential(t-1,:) + (dt./structure.decay).*(-structure.potential(t-1,:) + ...
                            noise + structure.baseline + (structure.epsilon+structure.lambda*neuromodulator)* ...
                            (inp_vec + (structure.activity(t-1,:)*structure.self_w)));
%multiple spikes check
for in=1:length(structure.activity(1,:))
    if t>6 && sum(structure.activity(t-6:t,in))>=1
        structure.potential(t,in) = 0;
        %disp ('Check')
    end
    if t>30 && sum(structure.activity(t-30:t,in))==0
        structure.potential(t,in) = 1.05*rand(1);
        %disp ('Check')
    end
end
                        
                        
%transfer function
structure.activity(t,:) = (structure.potential(t,:)>structure.th_out);


output = structure;