clear all
close all
%format short g
time=1200;
dt=0.5;
dim=100;
dim2=2;
n_input=1;
noi=0.5;      %0/1 noise for the input
da=0;
rng(10)  %5


init_var

inp_cl_mat=eye(100)*1.4;

%% ARENA
%arena_builder;
fig=figure('Name', 'Cortex layer', 'Position', [100 200 1500 500]);

subplot(1,2,1)
colormap(fmri_col)
title('Inputs')

subplot(1,2,1)
colormap(fmri_col)
title('Cortex')

%% video initialization
vd = VideoWriter('video1_spike', 'MPEG-4' );
%vd = VideoWriter('video1_spike');
frm=1;

%%
k=1;
flag1=0;
flag2=0;
%inp_crx1{3}=rand(1,100)/10;
input_range=[0 time 0.5 1.5];
for k = 2:time
    %inp_crx1=inp_crx1+rand(1,100)/50-0.01;

    if k==2
        nspk=1;
    elseif k>time/3 && k/3==floor(k/3) && nspk<dim
        nspk=nspk+1;
    end
    input_gen
    inp_spike(k,:)= ones(100,1)*inputs{1}(k,1);
    crx1=spike_step(k, dt, crx1, inp_spike(k,:)*inp_cl_mat, da);
    
    subplot(1,2,1)
    imagesc(inputs{1}(:,1)')
    %clims = [0 1];
    caxis([0 1])
    axis([1 k 0.5 1.5])
    %set(gca, 'XTick', [], 'YTick', []);
    %colormap(fmri_col)
    title('Inputs')
    %colorbar


    if k>25        
        avrg=sum(crx1.activity');    
        avrg(k)=sum(avrg(k-25:k));
    end
    if k<(time-200)
        subplot(1,2,2)
        imagesc(crx1.activity')
        axis([1 k 0.5 nspk+0.5])
        caxis([0 1])
        title('Output')
    else
        avrg=sum(crx1.activity');
        avrg(k)=sum(avrg(k-25:k));
        subplot(1,2,2)
        imagesc(sum(crx1.activity'))
        axis([1 k 0.5 1.5])
        %caxis([0 1])
        title('Output')
    end
        
    
    %%
    drawnow
    wait(15)
    
    %frame capture
    mvm(frm) = getframe(fig);
    frm=frm+1;
end

%% video recording
 open(vd)
 writeVideo(vd,mvm)
 close(vd)
